
include phos32.inc
includelib phos32.lib

.code


start:
        invoke start_phos_window, OFFSET phos_thread_func
        invoke ExitProcess, NULL
        
;==============================================================================
;PROCEDURE phos_thread_func = PROCEDURE phos_thread_func ======================   
;==============================================================================

;this is user specified code, executed in its own thread;
;Param is a pointer to the current lineBuffer; while the thread is executing,
;keyboard input is disabled;
;when the thread terminates, it sends a WM_FINISH message to the message queue;
;this message must be sent, so that the message handler can re-enable
;keyboard input and do some housekeeping

phos_thread_func proc infoStruc:DWORD

LOCAL prompt_line :DWORD
LOCAL hWin        :DWORD
LOCAL reason      :DWORD
    
    mov ebx, infoStruc

    mov eax, (phosThreadInfo PTR [ebx]).reason
    mov reason, eax

    mov eax, (phosThreadInfo PTR [ebx]).hWin
    mov hWin, eax
    
    ;prompt_line is zero terminated, nCols characters long,
    ;padded with spaces
    
    mov eax, (phosThreadInfo PTR [ebx]).ptrLineBuffer
    mov prompt_line, eax
    
    ;useful functions:
    ;=================
    ;phos_vscroll - scroll up by one line
    ;phos_set_colorscheme - set the colors used by the console
    ;phos_set_caption - set the window caption text
    ;phos_printstr - append strings to the prompt line   
    
    .if reason == VK_RETURN           ;user has pressed the enter key
            
      ;check if lineBuffer filled with spaces (line empty)
      invoke szCmp, OFFSET szEmptyLine, prompt_line
      
      .if eax == 0                    ;lineBuffer is not empty

        ;check if the user has entered the exit command
        szText szExitCommand, "exit", 0
        invoke InString, 1, prompt_line, OFFSET szExitCommand
        
        .if eax != 0                  ;string was found
        
          invoke Sleep, 500
          ;setting lparam of the message to 1 -> quit application
          invoke PostMessage, hWin, WM_FINISH, 0, 1
        
        .else
      
          ;invoke Sleep, 2000          ;simulate lengthy operation
                                       ;the window caption count
                                       ;the seconds elapsed
                                       ;window will still be fully
                                       ;responsive
          
          invoke phos_vscroll         ;scroll up user command    
          invoke phos_printstr,
                  OFFSET szDemoText,  ;zero terminated string
                  ColWHITE,           ;foreground color
                  0                   ;print from column zero
                  
          ;phos_printstr returns next column in eax
          inc eax
          invoke phos_printstr,
                  (phosThreadInfo PTR [ebx]).ptrLineBuffer,
                  ColYELLOW,
                  eax                 ;append to existing string
        
        .endif
        
      .endif
  
      invoke phos_vscroll
      
    .elseif eax == VK_UP            ;user has pressed the up arrow key
    .elseif eax == VK_DOWN          ;user has pressed the down arrow key
    
      ;implement some kind of BASH style command history   
    
    .endif
    
    ;must keep the following lines
    invoke PostMessage, hWin, WM_FINISH, 0, 0      ;do not delete 
    ret                                            ;do not delete

phos_thread_func endp
      
end start